diff --git a/gcc/m2/gm2-compiler/SymbolTable.mod b/gcc/m2/gm2-compiler/SymbolTable.mod
index 8fed8b3fc5d..5ef71ea9bad 100644
--- a/gcc/m2/gm2-compiler/SymbolTable.mod
+++ b/gcc/m2/gm2-compiler/SymbolTable.mod
@@ -14089,21 +14107,22 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: RETURN Procedure.Declared.Proper
+      ProcedureSym: Procedure.Decl[kind].ProcedureTok := tok
 
       ELSE
          InternalError ('expecting procedure symbol')
       END
    END
-END GetProcedureDeclaredProper ;
+END PutProcedureDeclaredTok ;
 
 
 (*
-   PutProcedureDeclaredProper - places the tok to which the forward
-                                declaration procedure occurred.
+   GetReturnTypeTok - return the token where the
+                               return type procedure sym:kind or proctype
+                               was defined.
 *)
 
-PROCEDURE PutProcedureDeclaredProper (sym: CARDINAL; tok: CARDINAL) ;
+PROCEDURE GetReturnTypeTok (sym: CARDINAL; kind: ProcedureKind) : CARDINAL ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -14111,21 +14130,24 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: Procedure.Declared.Proper := tok
+      ProcedureSym: RETURN Procedure.Decl[kind].ReturnTypeTok |
+      ProcTypeSym : RETURN ProcType.ReturnTypeTok
 
       ELSE
          InternalError ('expecting procedure symbol')
       END
    END
-END PutProcedureDeclaredProper ;
+END GetReturnTypeTok ;
 
 
 (*
-   GetProcedureDeclaredDefinition - return the token at which the forward
-                                    declaration procedure occurred.
+   PutReturnTypeTok - places the tok where the
+                      return type of procedure sym:kind or proctype
+                      was defined.
 *)
 
-PROCEDURE GetProcedureDeclaredDefinition (sym: CARDINAL) : CARDINAL ;
+PROCEDURE PutReturnTypeTok (sym: CARDINAL; kind: ProcedureKind;
+                                     tok: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -14133,35 +14155,34 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: RETURN Procedure.Declared.Definition
+      ProcedureSym: Procedure.Decl[kind].ReturnTypeTok := tok |
+      ProcTypeSym : ProcType.ReturnTypeTok := tok
 
       ELSE
          InternalError ('expecting procedure symbol')
       END
    END
-END GetProcedureDeclaredDefinition ;
+END PutReturnTypeTok ;
 
 
 (*
-   PutProcedureDeclaredDefinition - places the tok to which the forward
-                                    declaration procedure occurred.
+   GetProcedureKindDesc - return a string describing kind.
 *)
 
-PROCEDURE PutProcedureDeclaredDefinition (sym: CARDINAL; tok: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
+PROCEDURE GetProcedureKindDesc (kind: ProcedureKind) : String ;
 BEGIN
-   pSym := GetPsym (sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ProcedureSym: Procedure.Declared.Definition := tok
-
-      ELSE
-         InternalError ('expecting procedure symbol')
-      END
-   END
-END PutProcedureDeclaredDefinition ;
+   IF kind = ProperProcedure
+   THEN
+      RETURN InitString ('proper procedure')
+   ELSIF kind = ForwardProcedure
+   THEN
+      RETURN InitString ('forward procedure')
+   ELSIF kind = DefProcedure
+   THEN
+      RETURN InitString ('definition procedure')
+   END ;
+   InternalError ('unknown kind value')
+END GetProcedureKindDesc ;
 
 
 (*
@@ -14494,7 +14515,7 @@ END IsSubrange ;
 
 PROCEDURE IsProcedureVariable (Sym: CARDINAL) : BOOLEAN ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    RETURN( IsVar(Sym) AND IsProcedure(GetVarScope(Sym)) )
 END IsProcedureVariable ;
 
@@ -14519,7 +14540,7 @@ END IsProcedureNested ;
 
 PROCEDURE IsAModula2Type (Sym: CARDINAL) : BOOLEAN ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    RETURN(
            IsType(Sym) OR IsRecord(Sym) OR IsPointer(Sym) OR
            IsEnumeration(Sym) OR IsSubrange(Sym) OR IsArray(Sym) OR
@@ -14606,13 +14627,13 @@ END IsRegInterface ;
 
 PROCEDURE GetParam (Sym: CARDINAL; ParamNo: CARDINAL) : CARDINAL ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    IF ParamNo=0
    THEN
       (* Parameter Zero is the return argument for the Function *)
       RETURN(GetType(Sym))
    ELSE
-      RETURN(GetNthParam(Sym, ParamNo))
+      RETURN (GetNthParamAny (Sym, ParamNo))
    END
 END GetParam ;
 
@@ -14678,7 +14699,7 @@ PROCEDURE IsSizeSolved (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -14714,7 +14735,7 @@ PROCEDURE IsOffsetSolved (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -14738,7 +14759,7 @@ PROCEDURE IsValueSolved (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -14808,7 +14829,7 @@ PROCEDURE IsSumOfParamSizeSolved (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -14831,7 +14852,7 @@ PROCEDURE PushSize (Sym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -14860,27 +14881,39 @@ END PushSize ;
 
 
 (*
-   PushOffset - pushes the Offset of Sym.
+   PopSize - pops the ALU stack into Size of Sym.
 *)
 
-PROCEDURE PushOffset (Sym: CARDINAL) ;
+PROCEDURE PopSize (Sym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
-      VarSym          : PushFrom(Var.Offset) |
-      RecordFieldSym  : PushFrom(RecordField.Offset) |
-      VarientFieldSym : PushFrom(VarientField.Offset)
+      ProcedureSym    : PopInto(Procedure.Size) |
+      VarSym          : PopInto(Var.Size) |
+      TypeSym         : PopInto(Type.Size) |
+      RecordSym       : PopInto(Record.Size) |
+      VarientSym      : PopInto(Varient.Size) |
+      EnumerationSym  : PopInto(Enumeration.Size) |
+      PointerSym      : PopInto(Pointer.Size) |
+      ArraySym        : PopInto(Array.Size) |
+      RecordFieldSym  : PopInto(RecordField.Size) |
+      VarientFieldSym : PopInto(VarientField.Size) |
+      SubrangeSym     : PopInto(Subrange.Size) |
+      SubscriptSym    : PopInto(Subscript.Size) |
+      ProcTypeSym     : PopInto(ProcType.Size) |
+      UnboundedSym    : PopInto(Unbounded.Size) |
+      SetSym          : PopInto(Set.Size)
 
       ELSE
          InternalError ('not expecting this kind of symbol')
       END
    END
-END PushOffset ;
+END PopSize ;
 
 
 (*
@@ -14891,7 +14924,7 @@ PROCEDURE PushValue (Sym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -14919,7 +14952,7 @@ VAR
    pSym: PtrToSymbol ;
    a   : ARRAY [0..10] OF CHAR ;
 BEGIN
-   CheckLegal (Sym) ;
+   AssertInRange (Sym) ;
    pSym := GetPsym (Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -14941,95 +14974,6 @@ BEGIN
 END PushConstString ;
 
 
-(*
-   PushParamSize - push the size of parameter, ParamNo,
-                   of procedure Sym onto the ALU stack.
-*)
-
-PROCEDURE PushParamSize (Sym: CARDINAL; ParamNo: CARDINAL) ;
-VAR
-   p, Type: CARDINAL ;
-BEGIN
-   CheckLegal(Sym) ;
-   Assert(IsProcedure(Sym) OR IsProcType(Sym)) ;
-   IF ParamNo=0
-   THEN
-      PushSize(GetType(Sym))
-   ELSE
-      (*
-         can use GetNthParam but 1..n returns parameter.
-         But 0 yields the function return type.
-
-         Note that VAR Unbounded parameters and non VAR Unbounded parameters
-              contain the unbounded descriptor. VAR unbounded parameters
-              do NOT JUST contain an address re: other VAR parameters.
-      *)
-      IF IsVarParam(Sym, ParamNo) AND (NOT IsUnboundedParam(Sym, ParamNo))
-      THEN
-         PushSize(Address)     (* VAR parameters point to the variable *)
-      ELSE
-         p := GetNthParam(Sym, ParamNo) ; (* nth Parameter *)
-         (*
-            N.B. chose to get the Type of the parameter rather than the Var
-            because ProcType's have Type but no Var associated with them.
-         *)
-         Type := GetType(p) ;  (* ie Variable from Procedure Sym *)
-         Assert(p#NulSym) ;    (* If this fails then ParamNo is out of range *)
-         PushSize(Type)
-      END
-   END
-END PushParamSize ;
-
-
-(*
-   PushSumOfLocalVarSize - push the total size of all local variables
-                           onto the ALU stack.
-*)
-
-PROCEDURE PushSumOfLocalVarSize (Sym: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ProcedureSym,
-      DefImpSym,
-      ModuleSym   : PushSize(Sym)
-
-      ELSE
-         InternalError ('expecting Procedure, DefImp or Module symbol')
-      END
-   END
-END PushSumOfLocalVarSize ;
-
-
-(*
-   PushSumOfParamSize - push the total size of all parameters onto
-                        the ALU stack.
-*)
-
-PROCEDURE PushSumOfParamSize (Sym: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ProcedureSym: PushFrom(Procedure.TotalParamSize) |
-      ProcTypeSym : PushFrom(ProcType.TotalParamSize)
-
-      ELSE
-         InternalError ('expecting Procedure or ProcType symbol')
-      END
-   END
-END PushSumOfParamSize ;
-
-
 (*
    PushVarSize - pushes the size of a variable, Sym.
                  The runtime size of Sym will depend upon its addressing mode,
@@ -15040,7 +14984,7 @@ END PushSumOfParamSize ;
 
 PROCEDURE PushVarSize (Sym: CARDINAL) ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    Assert(IsVar(Sym)) ;
    IF GetMode(Sym)=LeftValue
    THEN
@@ -15060,7 +15004,7 @@ PROCEDURE PopValue (Sym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -15076,90 +15020,6 @@ BEGIN
 END PopValue ;
 
 
-(*
-   PopSize - pops the ALU stack into Size of Sym.
-*)
-
-PROCEDURE PopSize (Sym: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ProcedureSym    : PopInto(Procedure.Size) |
-      VarSym          : PopInto(Var.Size) |
-      TypeSym         : PopInto(Type.Size) |
-      RecordSym       : PopInto(Record.Size) |
-      VarientSym      : PopInto(Varient.Size) |
-      EnumerationSym  : PopInto(Enumeration.Size) |
-      PointerSym      : PopInto(Pointer.Size) |
-      ArraySym        : PopInto(Array.Size) |
-      RecordFieldSym  : PopInto(RecordField.Size) |
-      VarientFieldSym : PopInto(VarientField.Size) |
-      SubrangeSym     : PopInto(Subrange.Size) |
-      SubscriptSym    : PopInto(Subscript.Size) |
-      ProcTypeSym     : PopInto(ProcType.Size) |
-      UnboundedSym    : PopInto(Unbounded.Size) |
-      SetSym          : PopInto(Set.Size)
-
-      ELSE
-         InternalError ('not expecting this kind of symbol')
-      END
-   END
-END PopSize ;
-
-
-(*
-   PopOffset - pops the ALU stack into Offset of Sym.
-*)
-
-PROCEDURE PopOffset (Sym: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      VarSym          : PopInto(Var.Offset) |
-      RecordFieldSym  : PopInto(RecordField.Offset) |
-      VarientFieldSym : PopInto(VarientField.Offset)
-
-      ELSE
-         InternalError ('not expecting this kind of symbol')
-      END
-   END
-END PopOffset ;
-
-
-(*
-   PopSumOfParamSize - pop the total value on the ALU stack as the
-                       sum of all parameters.
-*)
-
-PROCEDURE PopSumOfParamSize (Sym: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ProcedureSym: PopInto(Procedure.TotalParamSize) |
-      ProcTypeSym : PopInto(ProcType.TotalParamSize)
-
-      ELSE
-         InternalError ('expecting Procedure or ProcType symbol')
-      END
-   END
-END PopSumOfParamSize ;
-
-
 (*
    PutAlignment - assigns the alignment constant associated with,
                   type, with, align.
diff --git a/gcc/testsuite/gm2/iso/fail/badexpression3.mod b/gcc/testsuite/gm2/iso/fail/badexpression3.mod
new file mode 100644
index 00000000000..c474674b541
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/fail/badexpression3.mod
@@ -0,0 +1,11 @@
+MODULE badexpression3 ;
+
+VAR
+   c: CARDINAL ;
+   i: INTEGER ;
+   r: CARDINAL ;
+BEGIN
+   c := 1 ;
+   i := 2 ;
+   r := c + i
+END badexpression3.
diff --git a/gcc/testsuite/gm2/iso/fail/badparam4.def b/gcc/testsuite/gm2/iso/fail/badparam4.def
new file mode 100644
index 00000000000..494f4453960
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/fail/badparam4.def
@@ -0,0 +1,5 @@
+DEFINITION MODULE badparam4 ;
+
+PROCEDURE foo (x, y: CARDINAL) ;
+
+END badparam4.
diff --git a/gcc/testsuite/gm2/iso/fail/badparam4.mod b/gcc/testsuite/gm2/iso/fail/badparam4.mod
new file mode 100644
index 00000000000..5c0b93da32f
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/fail/badparam4.mod
@@ -0,0 +1,8 @@
+IMPLEMENTATION MODULE badparam4 ;
+
+PROCEDURE foo (x: CARDINAL) ;
+BEGIN
+
+END foo ;
+
+END badparam4.

